#!/usr/bin/env python

try:
    from setuptools import setup
except ImportError:
    from distutils.core import setup

from setuptools import find_packages

from pycanvas import __version__ as version

long_description = 'A client library for accessing the Instructure Canvas rest library. Mostly generated by the swagger-codegen-cli tool.'

package_data = {
    '': ['LICENSE', 'README.md'],
}

# with open('README.md') as f:
#     readme = f.read()

setup(
    name='pycanvas',
    version=version,
    description='Client library for the Instructure Canvas REST api.',
    long_description=long_description,
    author='Paul Gower',
    author_email='p.gower@gmail.com',
    url='https://github.com/PGower/PyCanvas',
    download_url='https://github.com/PGower/PyCanvas/releases',
    package_dir={'pycanvas': 'pycanvas'},
    packages=find_packages(exclude=['*tests*']),
    package_data=package_data,
    license='BSD',
    classifiers=[
        'Development Status :: 3 - Alpha',
        'Environment :: Web Environment',
        'Programming Language :: Python',
        'Intended Audience :: Developers',
        'License :: OSI Approved :: MIT License',
        'Operating System :: OS Independent',
        'Topic :: Software Development :: Libraries :: Python Modules',
    ],
    keywords=['canvas', 'instructure'],
    install_requires=['requests'],
)